*
* Shared format routine used by the various versions of "printf"
* Input: Z=output pointer, X=argument pointer
*
_format_ LDY	0,X		;Y=format string
* Process next character from format string
?1	LDAA	0,Y		;Get next char
	AIY	#1		;Advance to next
	CMPA	#'%'		;Format string?
	BEQ	?2		;Yes, handle it
	STAA	0,Z		;Write to output
	AIZ	#1		;Advance output
	TSTA			;All done?
	BNE	?1		;No, keep going
	RTS
* Test for '-', left justify
?2	LDAA	0,Y		;Get next character
	LDAB	#' '		;Assume space
	CMPA	#'-'		;Left justify?
	BNE	?3		;No, its OK
	ORAB	#%10000000	;Set LJ bit
	AIY	#1		;Advance format string
	LDAA	0,Y		;Get next char
?3	CMPA	#'0'		;Zero fill?
	BNE	?4		;No, its OK
	ORAB	#'0'		;Convert to ZF
?4	STAB	?temp		;Save for later
* Evaluate field width
	CLRB			;Zero width
?5	LDAA	0,Y		;Get char
	SUBA	#'0'		;Convert to BIN
	CMPA	#10		;In range?
	BHS	?6		;No, end of number
	AIY	#1		;Advance pointer
	PSHA			;Save for later
	LDAA	#10		;X10 for decimal numbers
	MUL			;Get new result
	PULA			;Restore A
	ABA			;Add with old
	XGAB			;B=result
	BRA	?5		;And proceed
* Interpret the format specifier
?6	STAB	?temp+1		;Save width
	AIX	#-2		;Backup to next
	PSHM	X		;Save for later
	LDX	0,X		;Get argument value
	LDAA	0,Y		;Get format char
	AIY	#1		;Advance
* 'b' Binary number
	LDAB	#2		;Base 2
	CMPA	#'b'		;Binary output?
	BEQ	?8		;Yes, do it
* 'o' Octal number
	LDAB	#8		;Base 8
	CMPA	#'o'		;Octal output?
	BEQ	?8		;Yes, do it
* 'x' Hexidecimal number
	LDAB	#16		;Base 16
	CMPA	#'x'		;Hex output?
	BEQ	?8		;Yes, do it
* 'u' Unsigned number
	CMPA	#'u'		;Unsigned output?
	BEQ	?7		;Yes, do it
* 'd' Decimal number
	CMPA	#'d'		;Decimal output?
	BNE	?20		;No, try next
	PSHM	X		;Save X
	PULM	D		;Copy to D
	TSTA			;Check for negative
	BPL	?7		;No problems
	NEGD			;Negate
	XGDX			;And swap back
	LDAA	#'-'		;Get negative output
	STAA	0,Z		;Write in output
	AIZ	#1		;Advance
	LDAB	?temp+1		;Get length
	BEQ	?7		;Free format, its OK
	DEC	?temp+1		;Adjust length
?7	LDAB	#10		;Base 10 output
* Output number in X using base in B
?8	CLRA			;Zero count
	PSHA			;Save marker
* Process value & stack digits
?9	TDE			;Save a copy
	CLRA			;D = base only
	XGDX			;D=number, X=base
	IDIV			;X=num/base, D=num%base
	ADDB	#'0'		;Convert to ASCII
	CMPB	#'9'		;In range?
	BLS	?10		;Its OK
	ADDB	#7		;Convert hex digits
?10	PSHB			;Save new value
	TED			;D = count/base
	INCA			;Advance count
	CPX	#0		;More digits?
	BNE	?9		;Do them all
* Unpack digits into output buffer
	JSR	?40		;Left fill if necessary
?11	PULB			;Get char from stack
	TSTB			;End of string?
	BEQ	?12		;No, its OK
	STAB	0,Z		;Write it out
	AIZ	#1		;Advance
	BRA	?11		;And proceed
?12	TST	?temp		;Left justify?
	BPL	?13		;No, don't pad
	JSR	?50		;Pad on right
?13	PULM	X		;Restore X
	JMP	?1		;And proceed
* 's' string
?20	CMPA	#'s'		;String output?
	BNE	?30		;No, its not
	PSHM	X		;Save pointer
	LDAA	#255		;Start count (always loop once)
?21	INCA			;Advance count
	LDAB	0,X		;Get char
	AIX	#1		;Advance ptr
	TSTB			;End of string?
	BNE	?21		;Get length
	PULM	X		;Restore pointer
	JSR	?40		;Left fill if necessary
?22	LDAB	0,X		;Get char
	BEQ	?12		;End of string
	STAB	0,Z		;Write in output
	AIX	#1		;Advance source
	AIZ	#1		;Advance output
	BRA	?22		;And proceed
* 'c' Character
?30	CMPA	#'c'		;Character output
	BEQ	?31		;No, keep char
* Unknown charcter, re-stack last format & output
	TAB			;Copy charcter
	PULM	X		;Restore ARG ptr
	AIX	#2		;Advance to next
	PSHM	X		;Resave X
	XGDX			;Swap to unswap
?31	XGDX			;B = char
	LDAA	#1		;Width = 1
	JSR	?40		;Left fill if necessary
	STAB	0,Z		;Write in output
	AIZ	#1		;Advance output
	BRA	?12		;And proceed
*
* Pad the field assuming width in A
*
?40	TST	?temp		;Left justify?
	BMI	?54		;Yes, Don't pad
?50	PSHM	D,X		;Save A,B & X
	LDAB	?temp+1		;Fixed field?
	BEQ	?53		;No, exit
	LDAA	?temp		;Get fill char
	ANDA	#%00111111	;Save char
	TSX			;Address stack
?52	CMPB	2,X		;Over count?
	BLS	?53		;Yes, exit
	STAA	0,Z		;Write in output
	AIZ	#1		;Advance output
	DECB			;Reduce count
	BRA	?52		;And proceed
?53	PULM	D,X		;Restore A,B & X
?54	RTS
