*
* Test for ASCII character
*
isascii	LDD	#$007F		;Ascii range
	BRA	?1		;Perform test
*
* Test for uppercase alphabetic character (A-Z)
*
isupper	LDD	#'AZ'		;Range to test
	BRA	?1		;Perform test
*
* Test for lowercase alphabetic character (a-z)
*
islower	LDD	#'az'		;Range to test
	BRA	?1		;Perform test
*
* Test for graphic (printable) character
*
isgraph	LDD	#$217E		;Range to test
	BRA	?1		;And proceed
*
* Test for HEX digit
*
isxdigit TSX			;Address stack
	LDD	#'AF'		;Upper case range
	BSR	?11		;Perform test
	BNE	?21		;Yes, it's OK
	LDD	#'af'		;Lower case range
	BSR	?11		;Perform test
	BNE	?21		;Yes, it's OK
*
* Test for an ASCII digit (0-9)
*
isdigit	LDD	#'09'		;Range to test
* Test argument against range in A:B
?1	TSX			;Address stack
?11	CMPA	5,X		;Test LOWER limit
	BHI	?3		;Failed, return FALSE
	CMPB	5,X		;Test UPPER limit
	BLO	?3		;Failed, return FALSE
* Test that upper byte of argument is zero
?2	LDAA	4,X		;Get high byte
	BNE	?3		;Non-zero, fail
	LDAB	#1		;return 1
?21	RTS
* Report failure, return FALSE (0)
?3	CLRD			;Zero result
	RTS
*
* Test for CONTROL character
*
iscntrl	TSX			;Address stack
	LDAB	5,X		;Get argument
	CMPB	#$7F		;Delete.
	BEQ	?2		;Yes, test high
	LDD	#$001F		;CTRL-range
	BRA	?1		;Complete test
*
* Test for alphanumeric character (0-9, A-Z, a-z)
*
isalnum	TSX			;Address stack
	LDD	4,X		;Get argument
	PSHM	D		;Pass as argument
	BSR	isdigit		;Is it a digit.
	BNE	?5		;Yes, its OK
	BRA	?4		;Try alphas
*
* Test for alphabetic character (A-Z, a-z)
*
isalpha	TSX			;Address stack
	LDD	4,X		;Get argument
	PSHM	D		;Pass as argument
?4	BSR	isupper		;Uppercase.
	BNE	?5		;Yes, we have it
	BSR	islower		;Lowercase
?5	AIS	#2		;Clean up
	RTS
*
* Test for a punctuation character
*
ispunct	TSX			;Address stack
	LDD	4,X		;Get argument
	PSHM	D		;Pass as argument
	BSR	isalnum		;Alphanumeric.
	AIS	#2		;Clean up
	BNE	?3		;Yes, false
*
* Test for printable character
*
isprint	LDD	#$207E		;Printable range
	BRA	?1		;And test for it
*
* Test for a "space" character
*
isspace	TSX			;Address stack
	LDAB	5,X		;Get argument
	CMPB	#' '		;Space.
	BEQ	?2		;Seems OK
	CMPB	#9		;Tab.
	BEQ	?2		;Seems OK
	CMPB	#10		;Newline.
	BEQ	?2		;Seems OK
	BRA	?3		;Invalid
