*
* Allocate a block of memory: char *malloc(size)
*
malloc	LDY	#?heap		;Point to beginning of heap
* Search for free block of memory
?1	LDAA	0,Y		;Get allocation flag
	BEQ	?4		;End of heap, allocate here
	DECA			;Un-allocated?
	BNE	?2		;No, try next
* Found a free block, see if it is large enough
	LDD	1,Y		;Get block size
	TSX			;Address stack
	SUBD	4,X		;Large enough?
	BHS	?3		;Yes, allocate here
* Block not suitable, advance to next
?2	PSHM	Y		;Save 'Y'
	PULM	D		;Copy into D
	ADDD	#3		;Adjust for overhead
	ADDD	1,Y		;Offset to next block
	XGDY			;Set address back
	BRA	?1		;And try again
* This block is OK to re-allocate
?3	SUBD	#3		;Convert for overhead
	BLS	?6		;Not enough space, leave alone
	STD	?temp		;Save for later
* Split this block into two blocks
	PSHM	Y		;Save our pointer
	XGDY			;Get address for math
	ADDD	4,X		;Get block size
	XGDX			;X = next block pointer
	CLR	3,X		;Set it free
	INC	3,X		;Indicate de-allocated
	LDD	?temp		;Get leftover block size
	STD	4,X		;Save size of block
	PULM	Y		;Restore our pointer
	BRA	?5		;And proceed
* Allocate on end of memory
?4	TSX			;X = stack address
	XGDX			;D = stack address
	TSX			;X = stack address (again)
	SUBD	4,X		;Adjust for buffer size
	SUBD	#1000		;Adjust for margin ???
	STY	?temp		;Save for test
	CPD	?temp		;Enough free space?
	BLS	?7		;No, fail
* OK to proceed, allocate memory
	LDD	4,X		;Get size
	ADDD	?temp		;Offset to area
	XGDX			;X = end address
	CLR	3,X		;Indicate end of list
?5	TSX			;Address stack
	LDD	4,X		;Get size of parm
	STD	1,Y		;Save pointer
?6	LDAB	#2		;Get 'allocated' flag
	STAB	0,Y		;Set it
	XGDY			;D = address
	ADDD	#3		;Offset to data
	RTS
* Unable to allocate - failure
?7	CLRD			;Zero result
	RTS
*
* Release a block of memory: free(ptr)
*
free	TSX			;Address stack
	LDX	4,X		;Get address
	AIX	#-3		;Backup to real beginning
	STX	?temp		;Save for later compare
* Search allocation lst for this block
	LDX	#?heap		;Point to beginning of heap
?10	LDAA	0,X		;Get address
	BEQ	?12		;End of list
	CPX	?temp		;Is this it?
	BEQ	?11		;Yes, handle it
	PSHM	X		;Save 'X'
	PULM	D		;Copy to D
	ADDD	1,X		;Include size
	ADDD	#3		;Adjust for overhead
	XGDX			;Set address back
	BRA	?10		;And keep looking
* Mark this block as un-allocated
?11	LDAB	#1		;Get 'de-allocated' flag
	STAB	0,X		;Save it
* Garbage collection, scan allocation list and join any
* condiguous de-allocated blocks into single areas?
* Also, truncate list at last allocated block
?12	LDY	#?heap		;Point to list
?20	LDAA	0,Y		;Get allocation flag
	BEQ	?25		;End of table, quit
	DECA			;Allocated?
	BNE	?23		;Yes, leave alone
	LDD	1,Y		;Get initial offset
* This block is free, check following blocks
?21	STD	?temp		;Save offset
	TYX			;X=Block address
	XGDX			;Get address
	ADDD	?temp		;Adjust offset
	XGDX			;X = new address
	LDAA	3,X		;Get next block flag
	BEQ	?24		;End of list, truncate here
	DECA			;Allocated?
	BNE	?22		;Yes, leave alone
* Next block is also free
	LDD	?temp		;Get offset
	ADDD	4,X		;Include new block
	ADDD	#3		;Include overhead
	BRA	?21		;And proceed
* Resave this block size
?22	LDD	?temp		;Get size
	STD	1,Y		;Set new block size
* Advance to next block in list
?23	PSHM	Y		;Save 'Y'
	PULM	D		;Copy to D
	ADDD	1,Y		;Offset by block size
	ADDD	#3		;Adjust for overhead
	XGDY			;Set new address
	BRA	?20		;And proceed
* Mark this block as end of list
?24	CLR	0,Y		;Zero list
?25	RTS
