*
* Copy memory between RAM segments: segcopy(dseg, dptr, sseg, sptr, size)
*
segcopy	PSHM	Z		; Save stack frame
	TSZ			; Address parms
	LDD	14,Z		; Get dest segment
	TBYK			; Set Y extension
	LDY	12,Z		; Get dest offset
	LDD	10,Z		; Get source segment
	TBXK			; Set X extension
	LDX	8,Z		; Get source offset
	LDE	6,Z		; Get size
	BEQ	?4		; Zero length
* Align to word boundary if possible
	LDD	8,Z		; Get source offset
	LSRD			; Test for odd address
	BCC	?1		; No, its OK
* Move one byte to step source to word boundary
	LDAA	0,X		; Get byte
	STAA	0,Y		; Write it
	AIX	#1		; Advance source
	AIY	#1		; Advance dest
	SUBE	#1		; Reduce count
* Copy words until within 1 byte of end
?1	LSRE			; Convert to word count
	BEQ	?3		; Less than one word
	PSHM	CC		; Save state of CY
?2	LDD	0,X		; Read a word
	STD	0,Y		; Write a word
	AIX	#2		; Adjust source
	AIY	#2		; Adjust destination
	SUBE	#1		; Reduce count
	BNE	?2		; Proceed
	PULM	CC		; Restore condition code
* If odd count, copy last byte
?3	BCC	?4		; No last byte
	LDAA	0,X		; Get last byte
	STAA	0,Y		; Save last byte
* Restore state & exit
?4	TZKB			; Get out segment
	TBXK			; Reset X
	TBYK			; Reset Y
	PULM	Z		; Restore stack frame
	RTS
